﻿using HelloBlazorServer.Interfaces;
using HelloBlazorServer.Models;

namespace HelloBlazorServer.Services
{
    public class GangnamguPopulationService : IDatabase<GangnamguPopulation>
    {
        private readonly BlazorServerDbContext _context;

        public GangnamguPopulationService(BlazorServerDbContext context)
        {
            _context = context;
        }

        public void Create(GangnamguPopulation entity)
        {
            if (_context.GangnamguPopulations == null)
                throw new NullReferenceException();

            _context.GangnamguPopulations.Add(entity);
            _context.SaveChanges();
        }

        public void Delete(int? id)
        {
            if (_context.GangnamguPopulations == null)
                throw new NullReferenceException();

            var validData = _context.GangnamguPopulations.Find(id);
            if (validData == null)
                return;

            _context.GangnamguPopulations.Remove(validData);
            _context.SaveChanges();
        }

        public List<GangnamguPopulation>? Get()
        {
            if (_context.GangnamguPopulations == null)
                throw new NullReferenceException();

            return _context.GangnamguPopulations.ToList();
        }

        public GangnamguPopulation GetDetail(int? id)
        {
            if (_context.GangnamguPopulations == null)
                throw new NullReferenceException();

            var validData = _context.GangnamguPopulations.Find(id);
            if (validData == null)
                return null;

            return validData;
        }

        public void Update(int? id, GangnamguPopulation entity)
        {
            if (_context.GangnamguPopulations == null)
                throw new NullReferenceException();

            var validData = _context.GangnamguPopulations.Find(id);
            if (validData == null)
                return;

            _context.GangnamguPopulations.Update(entity);
            _context.SaveChanges();
        }
    }
}
